Index: uspace/srv/audio/hound/audio_data.c
===================================================================
--- uspace/srv/audio/hound/audio_data.c	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
+++ uspace/srv/audio/hound/audio_data.c	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
@@ -0,0 +1,315 @@
+/*
+ * Copyright (c) 2013 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup audio
+ * @brief HelenOS sound server
+ * @{
+ */
+/** @file
+ */
+
+#include <macros.h>
+#include <malloc.h>
+
+#include "audio_data.h"
+#include "log.h"
+
+/**
+ * Create reference counted buffer out of ordinary data buffer.
+ * @param data audio buffer
+ * @param size Size of the @p data buffer.
+ * @param fomart audio data format.
+ * @return pointer to valid audio data structre, NULL on failure.
+ */
+audio_data_t *audio_data_create(const void *data, size_t size,
+    pcm_format_t format)
+{
+	audio_data_t *adata = malloc(sizeof(audio_data_t));
+	if (adata) {
+		unsigned overflow = size % pcm_format_frame_size(&format);
+		if (overflow)
+			log_warning("Data not a multiple of frame size, "
+			    "clipping.");
+
+		adata->data = data;
+		adata->size = size - overflow;
+		adata->format = format;
+		atomic_set(&adata->refcount, 1);
+	}
+	return adata;
+}
+
+/**
+ * Get a new reference to the audio data buffer.
+ * @param adata The audio data buffer.
+ */
+void audio_data_addref(audio_data_t *adata)
+{
+	assert(adata);
+	assert(atomic_get(&adata->refcount) > 0);
+	atomic_inc(&adata->refcount);
+}
+
+/**
+ * Release a reference to the audio data buffer.
+ * @param adata The audio data buffer.
+ */
+void audio_data_unref(audio_data_t *adata)
+{
+	assert(adata);
+	assert(atomic_get(&adata->refcount) > 0);
+	atomic_count_t refc = atomic_predec(&adata->refcount);
+	if (refc == 0) {
+		free(adata->data);
+		free(adata);
+	}
+}
+
+/* Data link helpers */
+
+/** Audio data buffer list helper structure. */
+typedef struct {
+	link_t link;
+	audio_data_t *adata;
+	size_t position;
+} audio_data_link_t;
+
+/** List instance helper function.
+ * @param l link
+ * @return valid pointer to data link structure, NULL on failure.
+ */
+static inline audio_data_link_t * audio_data_link_list_instance(link_t *l)
+{
+	return l ? list_get_instance(l, audio_data_link_t, link) : NULL;
+}
+
+/**
+ * Create a new audio data link.
+ * @param adata Audio data to store.
+ * @return Valid pointer to a new audio data link structure, NULL on failure.
+ */
+static audio_data_link_t *audio_data_link_create(audio_data_t *adata)
+{
+	assert(adata);
+	audio_data_link_t *link = malloc(sizeof(audio_data_link_t));
+	if (link) {
+		audio_data_addref(adata);
+		link->adata = adata;
+		link->position = 0;
+	}
+	return link;
+}
+
+/**
+ * Destroy audio data link.
+ * @param link The link to destroy.
+ *
+ * Releases data reference.
+ */
+static void audio_data_link_destroy(audio_data_link_t *link)
+{
+	assert(link);
+	assert(!link_in_use(&link->link));
+	audio_data_unref(link->adata);
+	free(link);
+}
+
+/**
+ * Data link buffer start helper function.
+ * @param alink audio data link
+ * @return pointer to the beginning of data buffer.
+ */
+static inline const void * audio_data_link_start(audio_data_link_t *alink)
+{
+	assert(alink);
+	assert(alink->adata);
+	return alink->adata->data + alink->position;
+}
+
+/**
+ * Data link remaining size getter.
+ * @param alink audio data link
+ * @return Remaining size of valid data in the buffer.
+ */
+static inline size_t audio_data_link_remain_size(audio_data_link_t *alink)
+{
+	assert(alink);
+	assert(alink->adata);
+	assert(alink->position <= alink->adata->size);
+	return alink->adata->size - alink->position;
+}
+
+
+/**
+ * Data link remaining frames getter.
+ * @param alink audio data link
+ * @return Number of remaining frames in the buffer.
+ */
+static inline size_t audio_data_link_available_frames(audio_data_link_t *alink)
+{
+	assert(alink);
+	assert(alink->adata);
+	return pcm_format_size_to_frames(audio_data_link_remain_size(alink),
+	    &alink->adata->format);
+}
+
+/* Audio Pipe */
+
+/**
+ * Initialize audio pipe structure.
+ * @param pipe The pipe structure to initialize.
+ */
+void audio_pipe_init(audio_pipe_t *pipe)
+{
+	assert(pipe);
+	list_initialize(&pipe->list);
+	fibril_mutex_initialize(&pipe->guard);
+	pipe->frames = 0;
+	pipe->bytes = 0;
+}
+
+/**
+ * Destroy all data in a pipe.
+ * @param pipe The audio pipe to clean.
+ */
+void audio_pipe_fini(audio_pipe_t *pipe)
+{
+	assert(pipe);
+	while (!list_empty(&pipe->list)) {
+		audio_data_t *adata = audio_pipe_pop(pipe);
+		audio_data_unref(adata);
+	}
+}
+
+/**
+ * Add new audio data to a pipe.
+ * @param pipe The target pipe.
+ * @param data The data.
+ * @return Error code.
+ */
+int audio_pipe_push(audio_pipe_t *pipe, audio_data_t *data)
+{
+	assert(pipe);
+	assert(data);
+	audio_data_link_t *alink = audio_data_link_create(data);
+	if (!alink)
+		return ENOMEM;
+
+	fibril_mutex_lock(&pipe->guard);
+	list_append(&alink->link, &pipe->list);
+	pipe->bytes += audio_data_link_remain_size(alink);
+	pipe->frames += audio_data_link_available_frames(alink);
+	fibril_mutex_unlock(&pipe->guard);
+	return EOK;
+}
+
+/**
+ * Retrieve data form a audio pipe.
+ * @param pipe THe target pipe.
+ * @return Valid pointer to audio data, NULL if the pipe was empty.
+ */
+audio_data_t *audio_pipe_pop(audio_pipe_t *pipe)
+{
+	assert(pipe);
+	fibril_mutex_lock(&pipe->guard);
+	audio_data_t *adata = NULL;
+	link_t *l = list_first(&pipe->list);
+	if (l) {
+		audio_data_link_t *alink = audio_data_link_list_instance(l);
+		list_remove(&alink->link);
+		pipe->bytes -= audio_data_link_remain_size(alink);
+		pipe->frames -= audio_data_link_available_frames(alink);
+		adata = alink->adata;
+		audio_data_addref(adata);
+		audio_data_link_destroy(alink);
+	}
+	fibril_mutex_unlock(&pipe->guard);
+	return adata;
+}
+
+
+/**
+ * Use data store in a pipe and mix it into the provided buffer.
+ * @param pipe The piep that should provide data.
+ * @param data Target buffer.
+ * @param size Target buffer size.
+ * @param format Target data format.
+ * @return Size of the target buffer used, Error code on failure.
+ */
+ssize_t audio_pipe_mix_data(audio_pipe_t *pipe, void *data,
+    size_t size, const pcm_format_t *f)
+{
+	assert(pipe);
+
+	const size_t dst_frame_size = pcm_format_frame_size(f);
+	size_t needed_frames = pcm_format_size_to_frames(size, f);
+	size_t copied_size = 0;
+
+	fibril_mutex_lock(&pipe->guard);
+	while (needed_frames > 0 && !list_empty(&pipe->list)) {
+		/* Get first audio chunk */
+		link_t *l = list_first(&pipe->list);
+		audio_data_link_t *alink = audio_data_link_list_instance(l);
+
+		/* Get audio chunk metadata */
+		const size_t src_frame_size =
+		    pcm_format_frame_size(&alink->adata->format);
+		const size_t available_frames =
+		    audio_data_link_available_frames(alink);
+		const size_t copy_frames = min(available_frames, needed_frames);
+		const size_t dst_copy_size = copy_frames * dst_frame_size;
+		const size_t src_copy_size = copy_frames * src_frame_size;
+
+		assert(src_copy_size <= audio_data_link_remain_size(alink));
+
+		/* Copy audio data */
+		pcm_format_convert_and_mix(data, dst_copy_size,
+		    audio_data_link_start(alink), src_copy_size,
+		    &alink->adata->format, f);
+
+		/* Update values */
+		needed_frames -= copy_frames;
+		copied_size += dst_copy_size;
+		data += dst_copy_size;
+		alink->position += src_copy_size;
+		pipe->bytes -= src_copy_size;
+		pipe->frames -= copy_frames;
+		if (audio_data_link_remain_size(alink) == 0) {
+			list_remove(&alink->link);
+			audio_data_link_destroy(alink);
+		} else {
+			assert(needed_frames == 0);
+		}
+	}
+	fibril_mutex_unlock(&pipe->guard);
+	return copied_size;
+}
+
+/**
+ * @}
+ */
Index: uspace/srv/audio/hound/audio_data.h
===================================================================
--- uspace/srv/audio/hound/audio_data.h	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
+++ uspace/srv/audio/hound/audio_data.h	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
@@ -0,0 +1,132 @@
+/*
+ * Copyright (c) 2013 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup audio
+ * @brief HelenOS sound server
+ * @{
+ */
+/** @file
+ */
+
+#ifndef AUDIO_DATA_H_
+#define AUDIO_DATA_H_
+
+#include <adt/list.h>
+#include <atomic.h>
+#include <errno.h>
+#include <fibril_synch.h>
+#include <pcm/format.h>
+
+/** Reference counted audio buffer */
+typedef struct {
+	/** Audio data */
+	const void *data;
+	/** Size of the buffer pointer to by data */
+	size_t size;
+	/** Format of the audio data */
+	pcm_format_t format;
+	/** Reference counter */
+	atomic_t refcount;
+} audio_data_t;
+
+/** Audio data pipe structure */
+typedef struct {
+	/** List of audio data buffers */
+	list_t list;
+	/** Total size of all buffers */
+	size_t bytes;
+	/** Total frames stored in all buffers */
+	size_t frames;
+	/** List access synchronization */
+	fibril_mutex_t guard;
+} audio_pipe_t;
+
+audio_data_t * audio_data_create(const void *data, size_t size,
+    pcm_format_t format);
+void audio_data_addref(audio_data_t *adata);
+void audio_data_unref(audio_data_t *adata);
+
+void audio_pipe_init(audio_pipe_t *pipe);
+void audio_pipe_fini(audio_pipe_t *pipe);
+
+int audio_pipe_push(audio_pipe_t *pipe, audio_data_t *data);
+audio_data_t *audio_pipe_pop(audio_pipe_t *pipe);
+
+ssize_t audio_pipe_mix_data(audio_pipe_t *pipe, void *buffer, size_t size,
+    const pcm_format_t *f);
+
+/**
+ * Total bytes getter.
+ * @param pipe The audio pipe.
+ * @return Total size of buffer stored in the pipe.
+ */
+static inline size_t audio_pipe_bytes(audio_pipe_t *pipe)
+{
+	assert(pipe);
+	return pipe->bytes;
+}
+
+/**
+ * Total bytes getter.
+ * @param pipe The audio pipe.
+ * @return Total number of frames stored in the pipe.
+ */
+static inline size_t audio_pipe_frames(audio_pipe_t *pipe)
+{
+	assert(pipe);
+	return pipe->frames;
+}
+
+/**
+ * Push data form buffer directly to pipe.
+ * @param pipe The target pipe.
+ * @param data audio buffer.
+ * @param size size of the @p data buffer
+ * @param f format of the audio data.
+ * @return Error code.
+ *
+ * Reference counted buffer is created automatically.
+ */
+static inline int audio_pipe_push_data(audio_pipe_t *pipe,
+    const void *data, size_t size, pcm_format_t f)
+{
+	audio_data_t *adata = audio_data_create(data, size, f);
+	if (adata) {
+		const int ret = audio_pipe_push(pipe, adata);
+		audio_data_unref(adata);
+		return ret;
+	}
+	return ENOMEM;
+}
+
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/srv/audio/hound/audio_device.c
===================================================================
--- uspace/srv/audio/hound/audio_device.c	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
+++ uspace/srv/audio/hound/audio_device.c	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
@@ -0,0 +1,407 @@
+/*
+ * Copyright (c) 2012 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @addtogroup audio
+ * @brief HelenOS sound server.
+ * @{
+ */
+/** @file
+ */
+
+#include <assert.h>
+#include <async.h>
+#include <errno.h>
+#include <inttypes.h>
+#include <loc.h>
+#include <str.h>
+#include <str_error.h>
+
+
+#include "audio_device.h"
+#include "log.h"
+
+/* hardwired to provide ~21ms per fragment */
+#define BUFFER_PARTS   16
+
+static int device_sink_connection_callback(audio_sink_t *sink, bool new);
+static int device_source_connection_callback(audio_source_t *source, bool new);
+static void device_event_callback(ipc_callid_t iid, ipc_call_t *icall, void *arg);
+static int device_check_format(audio_sink_t* sink);
+static int get_buffer(audio_device_t *dev);
+static int release_buffer(audio_device_t *dev);
+static void advance_buffer(audio_device_t *dev, size_t size);
+static inline bool is_running(audio_device_t *dev)
+{
+	assert(dev);
+	/* we release buffer on stop so this should be enough */
+	return (bool)dev->buffer.base;
+}
+
+/**
+ * Initialize audio device structure.
+ * @param dev The structure to initialize.
+ * @param id Location service id of the device driver.
+ * @param name Name of the device.
+ * @return Error code.
+ */
+int audio_device_init(audio_device_t *dev, service_id_t id, const char *name)
+{
+	assert(dev);
+	link_initialize(&dev->link);
+	dev->id = id;
+	dev->name = str_dup(name);
+	dev->sess = audio_pcm_open_service(id);
+	if (!dev->sess) {
+		log_debug("Failed to connect to device \"%s\"", name);
+		return ENOMEM;
+	}
+
+	audio_sink_init(&dev->sink, name, dev, device_sink_connection_callback,
+	    device_check_format, NULL, &AUDIO_FORMAT_ANY);
+	audio_source_init(&dev->source, name, dev,
+	    device_source_connection_callback, NULL, &AUDIO_FORMAT_ANY);
+
+	/* Init buffer members */
+	dev->buffer.base = NULL;
+	dev->buffer.position = NULL;
+	dev->buffer.size = 0;
+	dev->buffer.fragment_size = 0;
+
+	log_verbose("Initialized device (%p) '%s' with id %" PRIun ".",
+	    dev, dev->name, dev->id);
+
+	return EOK;
+}
+
+/**
+ * Restore resource cplaimed during initialization.
+ * @param dev The device to release.
+ *
+ * NOT IMPLEMENTED
+ */
+void audio_device_fini(audio_device_t *dev)
+{
+	//TODO implement;
+}
+
+/**
+ * Get device provided audio source.
+ * @param dev Th device.
+ * @return pointer to aa audio source structure, NULL if the device is not
+ *         capable of capturing audio.
+ */
+audio_source_t * audio_device_get_source(audio_device_t *dev)
+{
+	assert(dev);
+	if (audio_pcm_query_cap(dev->sess, AUDIO_CAP_CAPTURE))
+		return &dev->source;
+	return NULL;
+}
+
+/**
+ * Get device provided audio sink.
+ * @param dev Th device.
+ * @return pointer to aa audio source structure, NULL if the device is not
+ *         capable of audio playback.
+ */
+audio_sink_t * audio_device_get_sink(audio_device_t *dev)
+{
+	assert(dev);
+	if (audio_pcm_query_cap(dev->sess, AUDIO_CAP_PLAYBACK))
+		return &dev->sink;
+	return NULL;
+}
+
+/**
+ * Handle connection addition and removal.
+ * @param sink audio sink that is connected or disconnected.
+ * @param new True of a connection was added, false otherwise.
+ * @return Error code.
+ *
+ * Starts playback on first connection. Stops playback when there are no
+ * connections.
+ */
+static int device_sink_connection_callback(audio_sink_t* sink, bool new)
+{
+	assert(sink);
+	audio_device_t *dev = sink->private_data;
+	if (new && list_count(&sink->connections) == 1) {
+		log_verbose("First connection on device sink '%s'", sink->name);
+
+		int ret = get_buffer(dev);
+		if (ret != EOK) {
+			log_error("Failed to get device buffer: %s",
+			    str_error(ret));
+			return ret;
+		}
+		audio_pcm_register_event_callback(dev->sess,
+		    device_event_callback, dev);\
+
+		/* Fill the buffer first. Fill the first two fragments,
+		 * so that we stay one fragment ahead */
+		pcm_format_silence(dev->buffer.base, dev->buffer.size,
+		    &dev->sink.format);
+		//TODO add underrun detection.
+		const size_t size = dev->buffer.fragment_size * 2;
+		/* We never cross the end of the buffer here */
+		audio_sink_mix_inputs(&dev->sink, dev->buffer.position, size);
+		advance_buffer(dev, size);
+
+		const unsigned frames = dev->buffer.fragment_size /
+		    pcm_format_frame_size(&dev->sink.format);
+		log_verbose("Fragment frame count %u", frames);
+		ret = audio_pcm_start_playback_fragment(dev->sess, frames,
+		    dev->sink.format.channels, dev->sink.format.sampling_rate,
+		    dev->sink.format.sample_format);
+		if (ret != EOK) {
+			log_error("Failed to start playback: %s",
+			    str_error(ret));
+			release_buffer(dev);
+			return ret;
+		}
+	}
+	if (list_count(&sink->connections) == 0) {
+		assert(!new);
+		log_verbose("Removed last connection on device sink '%s'",
+		    sink->name);
+		int ret = audio_pcm_stop_playback(dev->sess);
+		if (ret != EOK) {
+			log_error("Failed to stop playback: %s",
+			    str_error(ret));
+			return ret;
+		}
+	}
+	return EOK;
+}
+
+/**
+ * Handle connection addition and removal.
+ * @param source audio source that is connected or disconnected.
+ * @param new True of a connection was added, false otherwise.
+ * @return Error code.
+ *
+ * Starts capture on first connection. Stops capture when there are no
+ * connections.
+ */
+static int device_source_connection_callback(audio_source_t *source, bool new)
+{
+	assert(source);
+	audio_device_t *dev = source->private_data;
+	if (new && list_count(&source->connections) == 1) {
+		int ret = get_buffer(dev);
+		if (ret != EOK) {
+			log_error("Failed to get device buffer: %s",
+			    str_error(ret));
+			return ret;
+		}
+
+		//TODO set and test format
+
+		const unsigned frames = dev->buffer.fragment_size /
+		    pcm_format_frame_size(&dev->sink.format);
+		ret = audio_pcm_start_capture_fragment(dev->sess, frames,
+		    dev->source.format.channels,
+		    dev->source.format.sampling_rate,
+		    dev->source.format.sample_format);
+		if (ret != EOK) {
+			log_error("Failed to start recording: %s",
+			    str_error(ret));
+			release_buffer(dev);
+			return ret;
+		}
+	}
+	if (list_count(&source->connections) == 0) { /* Disconnected */
+		assert(!new);
+		int ret = audio_pcm_stop_capture_immediate(dev->sess);
+		if (ret != EOK) {
+			log_error("Failed to start recording: %s",
+			    str_error(ret));
+			return ret;
+		}
+	}
+
+	return EOK;
+}
+
+/**
+ * Audio device event handler.
+ * @param iid initial call id.
+ * @param icall initial call structure.
+ * @param arg (unused)
+ */
+static void device_event_callback(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	/* Answer initial request */
+	async_answer_0(iid, EOK);
+	audio_device_t *dev = arg;
+	assert(dev);
+	while (1) {
+		ipc_call_t call;
+		ipc_callid_t callid = async_get_call(&call);
+		async_answer_0(callid, EOK);
+		switch(IPC_GET_IMETHOD(call)) {
+		case PCM_EVENT_FRAMES_PLAYED: {
+			struct timeval time1;
+			getuptime(&time1);
+			//TODO add underrun detection.
+			/* We never cross the end of the buffer here */
+			audio_sink_mix_inputs(&dev->sink, dev->buffer.position,
+			    dev->buffer.fragment_size);
+			advance_buffer(dev, dev->buffer.fragment_size);
+			struct timeval time2;
+			getuptime(&time2);
+			log_verbose("Time to mix sources: %li\n",
+			    tv_sub(&time2, &time1));
+			break;
+		}
+		case PCM_EVENT_CAPTURE_TERMINATED: {
+			log_verbose("Capture terminated");
+			dev->source.format = AUDIO_FORMAT_ANY;
+			const int ret = release_buffer(dev);
+			if (ret != EOK) {
+				log_error("Failed to release buffer: %s",
+				    str_error(ret));
+			}
+			audio_pcm_unregister_event_callback(dev->sess);
+			break;
+		}
+		case PCM_EVENT_PLAYBACK_TERMINATED: {
+			log_verbose("Playback Terminated");
+			dev->sink.format = AUDIO_FORMAT_ANY;
+			const int ret = release_buffer(dev);
+			if (ret != EOK) {
+				log_error("Failed to release buffer: %s",
+				    str_error(ret));
+			}
+			audio_pcm_unregister_event_callback(dev->sess);
+			break;
+		}
+		case PCM_EVENT_FRAMES_CAPTURED: {
+			const int ret = audio_source_push_data(&dev->source,
+			    dev->buffer.position, dev->buffer.fragment_size);
+			advance_buffer(dev, dev->buffer.fragment_size);
+			if (ret != EOK)
+				log_warning("Failed to push recorded data");
+			break;
+		}
+		case 0:
+			log_info("Device event callback hangup");
+			return;
+		}
+
+	}
+}
+
+/**
+ * Test format against hardware limits.
+ * @param sink audio playback device.
+ * @return Error code.
+ */
+static int device_check_format(audio_sink_t* sink)
+{
+	assert(sink);
+	audio_device_t *dev = sink->private_data;
+	assert(dev);
+	/* Check whether we are running */
+	if (is_running(dev))
+		return EBUSY;
+	log_verbose("Checking format on sink %s", sink->name);
+	return audio_pcm_test_format(dev->sess, &sink->format.channels,
+	    &sink->format.sampling_rate, &sink->format.sample_format);
+}
+
+/**
+ * Get access to device buffer.
+ * @param dev Audio device.
+ * @return Error code.
+ */
+static int get_buffer(audio_device_t *dev)
+{
+	assert(dev);
+	if (!dev->sess) {
+		log_debug("No connection to device");
+		return EIO;
+	}
+	if (dev->buffer.base) {
+		log_debug("We already have a buffer");
+		return EBUSY;
+	}
+
+	/* Ask for largest buffer possible */
+	size_t preferred_size = 0;
+
+	const int ret = audio_pcm_get_buffer(dev->sess, &dev->buffer.base,
+	    &preferred_size);
+	if (ret == EOK) {
+		dev->buffer.size = preferred_size;
+		dev->buffer.fragment_size = dev->buffer.size / BUFFER_PARTS;
+		dev->buffer.position = dev->buffer.base;
+	}
+	return ret;
+
+}
+
+/**
+ * Surrender access to device buffer.
+ * @param dev Audio device.
+ * @return Error code.
+ */
+static int release_buffer(audio_device_t *dev)
+{
+	assert(dev);
+	assert(dev->buffer.base);
+
+	const int ret = audio_pcm_release_buffer(dev->sess);
+	if (ret == EOK) {
+		dev->buffer.base = NULL;
+		dev->buffer.size = 0;
+		dev->buffer.position = NULL;
+	} else {
+		log_warning("Failed to release buffer: %s", str_error(ret));
+	}
+	return ret;
+}
+
+/**
+ * Move buffer position pointer.
+ * @param dev Audio device.
+ * @param size number of bytes to move forward
+ */
+static void advance_buffer(audio_device_t *dev, size_t size)
+{
+	assert(dev);
+	assert(dev->buffer.position >= dev->buffer.base);
+	assert(dev->buffer.position < (dev->buffer.base + dev->buffer.size));
+	dev->buffer.position += size;
+	if (dev->buffer.position == (dev->buffer.base + dev->buffer.size))
+		dev->buffer.position = dev->buffer.base;
+}
+/**
+ * @}
+ */
Index: uspace/srv/audio/hound/audio_device.h
===================================================================
--- uspace/srv/audio/hound/audio_device.h	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
+++ uspace/srv/audio/hound/audio_device.h	(revision f7bb6d1a278f1b4a8dc824581598c48556371dca)
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2012 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup audio
+ * @brief HelenOS sound server
+ * @{
+ */
+/** @file
+ */
+
+#ifndef AUDIO_DEVICE_H_
+#define AUDIO_DEVICE_H_
+
+#include <adt/list.h>
+#include <async.h>
+#include <fibril_synch.h>
+#include <errno.h>
+#include <ipc/loc.h>
+#include <audio_pcm_iface.h>
+
+#include "audio_source.h"
+#include "audio_sink.h"
+
+/** Audio device structure. */
+typedef struct {
+	/** Link in hound's device list */
+	link_t link;
+	/** Location service id of the audio driver */
+	service_id_t id;
+	/** IPC session to the device driver. */
+	audio_pcm_sess_t *sess;
+	/** Device name */
+	char *name;
+	/** Device buffer */
+	struct {
+		void *base;
+		size_t size;
+		void *position;
+		size_t fragment_size;
+	} buffer;
+	/** Capture device abstraction. */
+	audio_source_t source;
+	/** Playback device abstraction. */
+	audio_sink_t sink;
+} audio_device_t;
+
+/** Linked list instance helper */
+static inline audio_device_t * audio_device_list_instance(link_t *l)
+{
+	return l ? list_get_instance(l, audio_device_t, link) : NULL;
+};
+
+int audio_device_init(audio_device_t *dev, service_id_t id, const char *name);
+void audio_device_fini(audio_device_t *dev);
+audio_source_t * audio_device_get_source(audio_device_t *dev);
+audio_sink_t * audio_device_get_sink(audio_device_t *dev);
+int audio_device_recorded_data(audio_device_t *dev, void **base, size_t *size);
+int audio_device_available_buffer(audio_device_t *dev, void **base, size_t *size);
+
+#endif
+
+/**
+ * @}
+ */
+
